package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;

import com.ekexiu.portal.po.ResearchAreaLog;
import com.ekexiu.portal.pojo.EditResearchAreaLog;

@DAO
public abstract class ResearchAreaLogDao {
	
	@Insert
	public abstract int insert(Connection con,ResearchAreaLog log) throws SQLException;
	
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId,String opreteProfessorId,String caption)throws SQLException;
	
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId,String caption)throws SQLException;
	@DeleteWith
	@From(ResearchAreaLog.class)
	public abstract int delete(Connection con,String professorId)throws SQLException;
	
	public List<EditResearchAreaLog> queryLimit(Connection con,String professorId,String caption,String createTime,int rows) throws SQLException{
        int index = 1;
        String sql = "SELECT OPRETE_PROFESSOR_ID,CREATE_TIME,PROFESSOR_ID,CAPTION FROM RESEARCH_AREA_LOG "
        		+ " WHERE CREATE_TIME < ? AND CAPTION = ? AND PROFESSOR_ID = ? ORDER BY CREATE_TIME DESC LIMIT "+rows;
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,createTime);
            ps.setString(index++,caption);
            ps.setString(index++,professorId);
            ResultSet rs = ps.executeQuery();
            try{
                List<EditResearchAreaLog> areaLogs = new ArrayList<EditResearchAreaLog>();
                while(rs.next()){
                	EditResearchAreaLog areaLog =  new EditResearchAreaLog();
                	areaLog.setOpreteProfessorId(rs.getString(1));
                	areaLog.setCreateTime(rs.getString(2));
                	areaLog.setProfessorId(rs.getString(3));
                	areaLog.setCaption(rs.getString(4));
                    areaLogs.add(areaLog);
                }
                return areaLogs;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }
	
	public List<EditResearchAreaLog> query(Connection con,String professorId) throws SQLException{
        int index = 1;
        String sql = "SELECT OPRETE_PROFESSOR_ID,CREATE_TIME,PROFESSOR_ID,CAPTION FROM RESEARCH_AREA_LOG WHERE PROFESSOR_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,professorId);
            ResultSet rs = ps.executeQuery();
            try{
                List<EditResearchAreaLog> areaLogs = new ArrayList<EditResearchAreaLog>();
                while(rs.next()){
                	EditResearchAreaLog log =  new EditResearchAreaLog();
                	log.setOpreteProfessorId(rs.getString(1));
                	log.setCreateTime(rs.getString(2));
                	log.setProfessorId(rs.getString(3));
                	log.setCaption(rs.getString(4));
                	areaLogs.add(log);
                }
                return areaLogs;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }

}
